<?php
/***************************************************************************
 *                                 db.php
 *                            -------------------
 *   begin                : Saturday, Feb 13, 2001
 *   copyright            : (C) 2001 The phpBB Group
 *   email                : support@phpbb.com
 *
 *   $Id: db.php,v 1.10 2002/03/18 13:35:22 psotfx Exp $
 *
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

if ( !defined('REDBLOG') )
{
	die("Permission denied");
}

switch($dbms)
{
	case 'mysql':
		include($root_path . 'db/mysql.php');
		break;

	case 'mysql4':
		include($root_path . 'db/mysql4.php');		
		break;

	case 'postgres':
		include($root_path . 'db/postgres7.php');
		break;

	case 'mssql':
		include($root_path . 'db/mssql.php');
		break;

	case 'oracle':
		include($root_path . 'db/oracle.php');
		break;

	case 'msaccess':
		include($root_path . 'db/msaccess.php');
		break;

	case 'mssql-odbc':
		include($root_path . 'db/mssql-odbc.php');
		break;
}

// Make the database connection.
$db = new sql_db($dbhost, $dbuser, $dbpasswd, $dbname, false);
if(!$db->db_connect_id)
{
   die("Could not connect to the database");
}

?>